/* eslint no-console: 0 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _tv4 = require('tv4');

var _tv42 = _interopRequireDefault(_tv4);

var _schemasJsonapiJson = require('./schemas/jsonapi.json');

var _schemasJsonapiJson2 = _interopRequireDefault(_schemasJsonapiJson);

var _errors = require('./errors');

var _jsonapiSerializer = require('jsonapi-serializer');

var _jsonapiSerializer2 = _interopRequireDefault(_jsonapiSerializer);

var Model = (function () {
  function Model() {
    var values = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    var schema = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];
    var Instancier = arguments.length <= 2 || arguments[2] === undefined ? Model : arguments[2];

    _classCallCheck(this, Model);

    if (!_lodash2['default'].isObject(values)) {
      throw new _errors.ArgumentError('Values must be an object not: ' + typeof values);
    }

    this.Instancier = Instancier;
    this.values = values;
    this.outputType = this.constructor.name.toLowerCase();
    this.schema = schema;
    this.identifierKey = 'id';

    // JSON VALIDATION
    this.isJsonApi = this.matchJsonApi(values);
    if (this.isJsonApi) {
      this.values = _lodash2['default'].assign({ id: _lodash2['default'].get(this.values, 'data.id') }, _lodash2['default'].get(this.values, 'data.attributes'));
    }

    this.jsonApiConfig = {
      keyForAttribute: 'camelCase',
      attributes: _lodash2['default'].chain(this.values).omit(this.identifierKey).keys().value()
    };
  }

  _createClass(Model, [{
    key: 'validate',
    value: function validate() {
      var v = this.toJson();

      var res = _tv42['default'].validateResult(v, this.schema);
      if (!res.valid) {
        throw new Error('Invalid format ' + this.constructor.name + ' ' + JSON.stringify(res));
      }
    }
  }, {
    key: 'validateCollection',
    value: function validateCollection() {
      var _this = this;

      _lodash2['default'].forEach(this.values, function (v) {
        var res = _tv42['default'].validateResult(new _this.Instancier(v).toJson(), _this.schema);
        if (!res.valid) {
          throw new Error('Invalid format ' + _this.constructor.name + ' ' + JSON.stringify(res));
        }
      });
    }
  }, {
    key: 'matchJsonApi',
    value: function matchJsonApi(data) {
      return _tv42['default'].validate(data, _schemasJsonapiJson2['default']);
    }
  }, {
    key: 'get',
    value: function get(key) {
      return _lodash2['default'].get(this.values, key);
    }
  }, {
    key: 'set',
    value: function set(key, value) {
      _lodash2['default'].set(this.values, key, value);
      return this;
    }
  }, {
    key: 'setJsonApiConfig',
    value: function setJsonApiConfig(config) {
      this.jsonApiConfig = _lodash2['default'].assign(this.jsonApiConfig, config);
      return this;
    }
  }, {
    key: 'toJson',
    value: function toJson() {
      return new _jsonapiSerializer2['default'](this.outputType, this.values, this.jsonApiConfig);
    }
  }]);

  return Model;
})();

exports['default'] = Model;
module.exports = exports['default'];